# -*- coding: utf-8 -*-
from setuphelpers import *

fw_rule_name_py = "WAPT Python"
fw_rule_name_py_scripts = "WAPT Python Scripts"


def install():
    wapt_python_path = makepath(WAPT.wapt_base_dir, "waptpython.exe")
    wapt_python_scripts_path = makepath(WAPT.wapt_base_dir, "Scripts", "python.exe")

    # Removing rules to prevent duplication
    uninstall()

    # Creating rules
    print(f"Opening firewall rules for {fw_rule_name_py}")
    if windows_version() < WindowsVersions.Windows10:
        run_notfatal(f'netsh advfirewall firewall add rule name="{fw_rule_name_py}" dir=in action=allow program="{wapt_python_path}" enable=yes')
        run_notfatal(
            f'netsh advfirewall firewall add rule name="{fw_rule_name_py_scripts}" dir=in action=allow program="{wapt_python_scripts_path}" enable=yes'
        )
        run_notfatal(f'netsh advfirewall firewall add rule name="{fw_rule_name_py}" dir=out action=allow program="{wapt_python_path}" enable=yes')
        run_notfatal(
            f'netsh advfirewall firewall add rule name="{fw_rule_name_py_scripts}" dir=out action=allow program="{wapt_python_scripts_path}" enable=yes'
        )

    else:
        run_powershell(
            f'New-NetFirewallRule -DisplayName "{fw_rule_name_py}" -Direction Inbound -Action Allow -Program "{wapt_python_path}" -Enabled True -Group WAPT'
        )
        run_powershell(
            f'New-NetFirewallRule -DisplayName "{fw_rule_name_py_scripts}" -Direction Inbound -Action Allow -Program "{wapt_python_scripts_path}" -Enabled True -Group WAPT'
        )
        run_powershell(
            f'New-NetFirewallRule -DisplayName "{fw_rule_name_py}" -Direction Outbound -Action Allow -Program "{wapt_python_path}" -Enabled True -Group WAPT'
        )
        run_powershell(
            f'New-NetFirewallRule -DisplayName "{fw_rule_name_py_scripts}" -Direction Outbound -Action Allow -Program "{wapt_python_scripts_path}" -Enabled True -Group WAPT'
        )


def uninstall():
    print("Removing firewall rules")
    if windows_version() < WindowsVersions.Windows10:
        run_notfatal('netsh advfirewall firewall delete rule name="%s"' % fw_rule_name_py)
        run_notfatal('netsh advfirewall firewall delete rule name="%s"' % fw_rule_name_py_scripts)
    else:
        run_powershell(f'Remove-NetFirewallRule -DisplayName "{fw_rule_name_py}" -ErrorAction SilentlyContinue', accept_returncodes=[0, 1, 3010])
        run_powershell(f'Remove-NetFirewallRule -DisplayName "{fw_rule_name_py_scripts}" -ErrorAction SilentlyContinue', accept_returncodes=[0, 1, 3010])
